Package ghidra.app.util.bin.format.dwarf.attribs

# Class DWARFAttribute.AttrDef

java.lang.Object
ghidra.app.util.bin.format.dwarf.attribs.DWARFAttributeDef<DWARFAttribute>
ghidra.app.util.bin.format.dwarf.attribs.DWARFAttribute.AttrDef

Enclosing class:
  `DWARFAttribute`

public static class DWARFAttribute.AttrDef extends DWARFAttributeDef<DWARFAttribute>
Represents how a specific DWARF attribute is stored in a DIE record.

- ## Field Summary

  ### Fields inherited from class ghidra.app.util.bin.format.dwarf.attribs.DWARFAttributeDef

  `attributeForm, attributeId, implicitValue, rawAttributeId`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `AttrDef(DWARFAttribute attributeId, int rawAttributeId, DWARFForm attributeForm, long implicitValue)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected String`
  `getRawAttributeIdDescription()`
  `static DWARFAttribute.AttrDef`
  `read(BinaryReader reader)`
  Reads a `DWARFAttribute.AttrDef` instance from the `reader`.
  `DWARFAttribute.AttrDef`
  `withForm(DWARFForm newForm)`

  ### Methods inherited from class ghidra.app.util.bin.format.dwarf.attribs.DWARFAttributeDef

  `equals, getAttributeForm, getAttributeId, getAttributeName, getImplicitValue, getRawAttributeId, hashCode, isImplicit, read, toString`

  ### Methods inherited from class java.lang.Object

  `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- ## Constructor Details

  - ### AttrDef

    public AttrDef(DWARFAttribute attributeId, int rawAttributeId, DWARFForm attributeForm, long implicitValue)

- ## Method Details

  - ### read

    public static DWARFAttribute.AttrDef read(BinaryReader reader) throws IOException
    Reads a `DWARFAttribute.AttrDef` instance from the `reader`.

    Returns a null if its a end-of-list marker.

    Parameters:
      `reader` - `BinaryReader` abbr stream
    Returns:
      new `DWARFAttribute.AttrDef`, or null if end-of-list
    Throws:
      `IOException` - if error reading

  - ### getRawAttributeIdDescription

    protected String getRawAttributeIdDescription()
    Overrides:
      `getRawAttributeIdDescription` in class `DWARFAttributeDef<DWARFAttribute>`

  - ### withForm

    public DWARFAttribute.AttrDef withForm(DWARFForm newForm)
    Overrides:
      `withForm` in class `DWARFAttributeDef<DWARFAttribute>`